import numpy as np
import scipy.optimize as resol
from matplotlib import pyplot as plt
import scipy.integrate as integr

def p(v,t):# p, v et t sont les pression, volume et température réduits
    return 8*t/(3*v-1)-3/v**2
    
V=np.linspace(.334,4,500) # valeurs de v
T=np.linspace(.6,1.2,61)# valeurs de t





def f(v,t):# la dérivée dp/dV pour T donné est proportionnelle à f(v,t)
    return 4*t*v**3-(3*v-1)**2
    
def isotherme(t):
    if t >1.2 or t<.6:
        print('t doit être compris entre 0,6 et 1,2')
    else:
        P=[]
        for elt in V:
            P.append(p(elt,t))
        plt.plot(V,P)
        plt.ylim(-3,3)
        plt.show()
        
def dichotomie(f,t,a,b,eps):
    c=0.5*(a+b)
    while (b-a)>eps:
        if f(a,t)*f(c,t)<0:
            b=c
        else:
            a=c
        c=0.5*(a+b)
    return c
    

eps=1E-6

def trace(choix):
    if choix==2:
        for i in range(40):
            t=.6+i*.01
            v1=dichotomie(f,t,0.334,1,eps)
            v2=dichotomie(f,t,1,100,eps)
            
            def g(v,t):
                c=p(v,t)
                def h(v,t):
                    return p(v,t)-c
                a=dichotomie(h,t,.334,v1,eps)
                b=dichotomie(h,t,v2,100,eps)
                return integr.quad(p,a,b,args=(t))[0]-p(v,t)*(b-a)
                
            v3=dichotomie(g,t,v1,v2,eps)
            p3=p(v3,t)
           
            def H(v,t):
                return p(v,t)-p3
                
            V1=dichotomie(H,t,0.334,v1,eps)
            V2=dichotomie(H,t,v2,100,eps)
            
            L=[]
            for elt in V:
                if V1<=elt<=V2:
                    L.append(p3)
                else:
                    L.append(p(elt,t))
            plt.plot(V,L)
            
        for i in range(21):
            t=1+i*.01
            P=[]
            for b in V:
                P.append(p(b,t))
            plt.plot(V,P)
        plt.ylim(0,1.5)
        plt.show()
        
    elif choix==1:
        for a in T:
            P=[]
            for b in V:
                P.append(p(b,a))
            plt.plot(V,P)
        plt.ylim(0,1.5)
        plt.show()
        
    else:
        print('taper 1 ou 2')







